function AaoFmcLink() {
	var AAO_FMC_URL = "b787fmc/fmc.html";
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var apiport = 0;
	var dloop;

	function DataLoop () {
		// AAO data reader
		let forceUpdate = SimVar.GetSimVarValue('L:AAO_FMC_HTML_INIT', 'Number');
		apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let cdulist = document.getElementsByClassName("wt787-cdu");
			if (cdulist && cdulist.length > 0) {
				let screen = cdulist[0].innerHTML;
				if (forceUpdate == 1 || lastAaoSend !== screen) {
					lastAaoSend = screen;
					let tosend = { "fname": AAO_FMC_URL, "part": 0, "of": 1, "isvirtual": "true", "base64": window.btoa(unescape(encodeURIComponent(screen))) };
					let requestObj = {};
					requestObj.files = [];
					requestObj.files.push(tosend);
					let relxhttp = new XMLHttpRequest();
					let relurl = encodeURI(AAO_URL_PART + apiport + "/webapi/");
					relxhttp.open("POST", relurl, true);
					relxhttp.send(JSON.stringify(requestObj));
					SimVar.SetSimVarValue("L:AAO_FMC_HTML_INIT", "Number", 0);
				}
				if (!this._aaoUpCnt)
					this._aaoUpCnt = 1;
				this._aaoUpCnt++;
				if (this._aaoUpCnt > 3) {
					this._aaoUpCnt = 1;
					var getrequestObj = {};
					getrequestObj.getstringvars = [];
					var tosend = { "var": "(L:AAO_FMC_BUTTON, String)", "value": "" };
					getrequestObj.getstringvars.push(tosend);
					var relxhttp = new XMLHttpRequest();
					relxhttp.addEventListener("load", aaoDataRequestListener);
					var getrelurl = encodeURI(AAO_URL_PART + apiport + "/webapi?json=" + (JSON.stringify(getrequestObj)));
					getrelurl = getrelurl.replace(/\+/g, '%2B');
					relxhttp.open("GET", getrelurl);
					relxhttp.send();
				}
			}
		}
		// end AAO data reader
	};

	// AAO remote input handler
	function aaoDataRequestListener () {
		let commObj = JSON.parse(this.responseText);
		let eleid = commObj.getstringvars[0].value;
        if (eleid.length > 0) {
			let setrequestObj = {};
			setrequestObj.setstringvars = [];
			let tosend = { "var": "(>L:AAO_FMC_BUTTON, String)", "value": ""};
			setrequestObj.setstringvars.push(tosend);
			let relxhttp = new XMLHttpRequest();
			let getrelurl = encodeURI(AAO_URL_PART + apiport + "/webapi?json=" + (JSON.stringify(setrequestObj)));
			getrelurl = getrelurl.replace(/\+/g, '%2B');
			relxhttp.open("GET", getrelurl);
			relxhttp.send();
			var qss = document.querySelectorAll(".wt787-cdu-button");
			var eleidx = parseInt(eleid);
			var elefire = qss[eleidx];
			var ev = new MouseEvent('click', {
				'view': window,
				'bubbles': true,
				'cancelable': true,
				'screenX': (elefire.offsetLeft + 10),
				'screenY': (elefire.offsetTop + 10)
			});
			elefire.dispatchEvent(ev);
        }
	};

	this.startup = function () {
		setInterval(DataLoop, 55);
	};
	
			
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaofmcmodule = new AaoFmcLink();
aaofmcmodule.startup();
    